﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Event_DogArrivesHome : WorldEventsManager
{
    [SerializeField] AudioClip clip;
    [SerializeField] List<ThinkingCloud> clouds;
    AudioSource audioSource;

    private new void Awake()
    {
        base.Awake();
        audioSource = GetComponent<AudioSource>();
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.gameObject != dog.gameObject) return;

        StartCoroutine(Ending());
    }

    private IEnumerator Ending()
    {
        dog.gameObject.SetActive(false);
        yield return new WaitForSeconds(1);
        audioSource.PlayOneShot(clip, 1f);
        yield return new WaitForSeconds(0.2f);
        audioSource.PlayOneShot(clip, 1f);
        yield return new WaitForSeconds(0.7f);
        clouds[0].EnqueueImageToShow(ImageLibrary.instance.alert);
        clouds[0].EnqueueImageToShow(ImageLibrary.instance.dog);
        yield return new WaitForSeconds(2.4f);
        clouds[1].EnqueueImageToShow(ImageLibrary.instance.dog);
        clouds[2].EnqueueImageToShow(ImageLibrary.instance.dog);

        for (int i=0; i<=2; i++)
        {
            clouds[i].timeToShowEachImage = 100000;
            clouds[i].EnqueueImageToShow(ImageLibrary.instance.heart);
        }

        yield return new WaitForSeconds(2f);

        clouds[3].EnqueueImageToShow(ImageLibrary.instance.home);
        clouds[3].EnqueueImageToShow(ImageLibrary.instance.heart);
        yield return new WaitUntil(() => !clouds[3].gameObject.activeSelf);
        clouds[3].timeToShowEachImage = 3;
        clouds[3].EnqueueImageToShow(ImageLibrary.instance.meat);
        clouds[3].timeToShowEachImage = 100000;
        clouds[3].EnqueueImageToShow(ImageLibrary.instance.heart);

    }
}
