﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameOverManager : WorldEventsManager
{

    [SerializeField] Transform respawnPosition;
    //[SerializeField] AudioClip gameOverSound;
    [SerializeField] AudioSource musicSource;
    AudioSource audioSource;

    private new void Awake()
    {
        base.Awake();
        instance = this;
        audioSource = GetComponent<AudioSource>();
    }

    public static GameOverManager instance
    {
        get; private set;
    }


    public void Run()
    {
        StartCoroutine(GameOver());
    }

    private IEnumerator GameOver()
    {
        dog.hearCars.enabled = false;

        float initialVolume = musicSource.volume;
        musicSource.volume = 0;
        StopAllCarsSounds();
        audioSource.Play();

        for (float t = 1; t > 0.001f; t = t * 0.5f)
        {
            Time.timeScale = t;
            yield return new WaitForEndOfFrame();
        }

        yield return new WaitForSecondsRealtime(1f);

        Time.timeScale = 1;
        Respawn respawn = dog.GetComponent<Respawn>();
        respawn.Run();

        dog.hearCars.enabled = true;
        musicSource.volume = initialVolume;
    }

    private void StopAllCarsSounds()
    {
        foreach (var engineAudio in FindObjectsOfType<EngineAudio>())
        {
            var audio = engineAudio.GetComponent<AudioSource>();
            audio.Stop();
            Destroy(audio);
            Destroy(engineAudio);
        }
    }

}
