﻿
using System;
using System.Collections;
using UnityEngine;

public class Tutorial_Cross_Street : WorldEventsManager
{
    [SerializeField] EventOnTriggerEnter aboutToCrossEvent;

    private bool firstTime = true;

    void Start()
    {
        aboutToCrossEvent.OnTriggerEnter += AboutToCrossHandler;
    }

    private void AboutToCrossHandler()
    {
        if (dog.think.IsThinking()) return;

        if (firstTime) dog.movement.enabled = false;

        dog.think.ThinkIn(ImageLibrary.instance.alert);
        dog.think.ThinkIn(ImageLibrary.instance.car);
        dog.think.ThinkIn(ImageLibrary.instance.listen);

        if (firstTime) StartCoroutine(EnableMovementAfterThinking());
        firstTime = false;
    }

    private IEnumerator EnableMovementAfterThinking()
    {
        yield return new WaitUntil(() => !dog.think.IsThinking());
        dog.movement.enabled = true;
    }
}
