﻿using UnityEngine;

public class EngineAudio : MonoBehaviour
{
    public AudioClip engineClip;
    public Transform target;
    private AudioSource audioSource;
    private StraightMovement carMovement;

    void Start()
    {
        carMovement = GetComponent<StraightMovement>();
        audioSource = gameObject.AddComponent<AudioSource>();
        audioSource.clip = engineClip;
        audioSource.playOnAwake = false;
        audioSource.loop = true;
        audioSource.Play();
    }

    void Update()
    {
        Vector2 currentDistance = target.position - transform.position;
        Vector2 nextDistance = target.position - (transform.position + (Vector3)carMovement.direction * 10);
        if (currentDistance.magnitude > nextDistance.magnitude)
        {
            audioSource.pitch = 2.2f;
            audioSource.volume = 1.2f - currentDistance.magnitude / 150f;
        }
        else
        {
            audioSource.pitch = 1.9f;
            audioSource.volume = 1f - currentDistance.magnitude / 30f;
        }

    }
}
