﻿
using System;
using UnityEngine;

public abstract class Interactable : MonoBehaviour
{
    protected new Collider2D collider;
    protected new SpriteRenderer renderer;

    public event Action OnInteract;
    public event Action OnInteractSuccess;

    protected void Awake()
    {
        collider = GetComponent<Collider2D>();
        renderer = GetComponent<SpriteRenderer>();
    }

    public abstract void Interact();

    protected void InvokeOnInteract()
    {
        OnInteract.SafeInvoke();
    }

    protected void InvokeOnInteractSuccess()
    {
        OnInteractSuccess.SafeInvoke();
    }
}
