﻿
using System;
using System.Collections;
using UnityEngine;

public class InteractableShowObject : Interactable
{
    [SerializeField] GameObject objectToShow;
    [SerializeField] float timeToShow;

    private void Awake()
    {
        base.Awake();
        objectToShow.SetActive(false);
    }

    public override void Interact()
    {
        InvokeOnInteract();
        if (objectToShow.activeSelf) return;

        StartCoroutine(ShowObject());
        InvokeOnInteractSuccess();
    }

    private IEnumerator ShowObject()
    {
        objectToShow.SetActive(true);
        yield return new WaitForSeconds(timeToShow);
        objectToShow.SetActive(false);
    }
}
