﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FiremanOutsideBehavior : Interactable
{

    [SerializeField] LadyInteraction ladyInteraction;
    [SerializeField] ThinkingCloud cloud;
    [SerializeField] StraightMovement movement;
    [SerializeField] Transform movementTarget;
    Animator anim;

    void Start()
    {
        anim = GetComponent<Animator>();
        StartCoroutine(BehaviorRoutine());
    }

    IEnumerator BehaviorRoutine()
    {
        while (true)
        {
            yield return new WaitForEndOfFrame();
            if (!ladyInteraction.IsInteracting) continue;
            yield return new WaitForSeconds(1f);
            if (!ladyInteraction.IsInteracting) continue;

            cloud.EnqueueImageToShow(ImageLibrary.instance.dots);
            yield return new WaitForSeconds(1);
            if (!ladyInteraction.IsInteracting) continue;
            yield return new WaitForSeconds(1);
            if (!ladyInteraction.IsInteracting) continue;
            yield return new WaitForSeconds(1);
            if (!ladyInteraction.IsInteracting) continue;
            cloud.EnqueueImageToShow(ImageLibrary.instance.angry);
            break;
        }

        movement.direction = (movementTarget.position - transform.position).normalized;
        movement.enabled = true;
        renderer.flipX = movement.direction.x > 0;
        anim.SetFloat("speed", 1);
    }

    public override void Interact()
    {

    }
}
