﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LadyInteraction : Interactable
{

    private Animator anim;
    public Dog dog;

    private void Start()
    {
        anim = GetComponent<Animator>();
        dog = FindObjectOfType<Dog>();
    }

    public override void Interact()
    {
        StartCoroutine(InteractWithDogRoutine());
    }

    private IEnumerator InteractWithDogRoutine()
    {
        anim.SetBool("interacting", true);

        while (Vector3.Distance(transform.position, dog.transform.position) < 2)
        {
            renderer.flipX = dog.transform.position.x > transform.position.x;
            yield return new WaitForEndOfFrame();
        }

        renderer.flipX = true;

        anim.SetBool("interacting", false);

    }

    public bool IsInteracting
    {
        get
        {
            return anim.GetBool("interacting");
        }
    }
}
