﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PhotographerGuardsHisPhotos : MonoBehaviour
{
    [SerializeField] Interactable photos;
    [SerializeField] ThinkingCloud cloud;
    SpriteRenderer spriteRenderer;
    PhotographerTakePicturesRandomly pictureTaking;

    void Start()
    {
        spriteRenderer = GetComponent<SpriteRenderer>();
        pictureTaking = GetComponentInChildren<PhotographerTakePicturesRandomly>();
    }

    private void OnEnable()
    {
        photos.OnInteract += GuardPhotos;
    }

    private void OnDisable()
    {
        photos.OnInteract -= GuardPhotos;
    }

    private void GuardPhotos()
    {
        StopAllCoroutines();
        StartCoroutine(GuardRoutine());
    }

    private IEnumerator GuardRoutine()
    {
        spriteRenderer.flipX = false;
        pictureTaking.enabled = false;

        if (!cloud.gameObject.activeSelf) cloud.EnqueueImageToShow(ImageLibrary.instance.alert);
        yield return new WaitForSeconds(3f);

        pictureTaking.enabled = true;
        spriteRenderer.flipX = true;
    }
}
