﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PhotographerTakePicturesRandomly : MonoBehaviour
{

    public float playSoundIfDistanceIsLessThan = 10f;

    AudioSource audioSource;
    Animator anim;

    private void Awake()
    {
        anim = GetComponent<Animator>();
        audioSource = GetComponent<AudioSource>();
    }


    private void OnEnable()
    {
        StartCoroutine(TakingPicturesRoutine());
    }

    private void OnDisable()
    {
        StopAllCoroutines();
    }

    private IEnumerator TakingPicturesRoutine()
    {
        Dog dog = FindObjectOfType<Dog>();
        while (true)
        {
            yield return new WaitForSeconds(GetRandomTime());
            anim.SetTrigger("takePicture");
            if (Vector3.Distance(dog.transform.position, transform.position) < playSoundIfDistanceIsLessThan)
            {
                audioSource.Play();
            }
        }
    }

    private float GetRandomTime()
    {
        return Random.Range(1f, 8f);
    }

}
