﻿using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class AbilityHearCarsOnRoads : MonoBehaviour
{

    [SerializeField] LayerMask layerMask;
    [SerializeField] AudioClip carAudio;

    private void OnTriggerStay2D(Collider2D collision)
    {
        if (!enabled) return;
        if (!collision.gameObject.IsInLayerMask(layerMask)) return;

        Road road = collision.GetComponent<Road>();
        GameObject carsContainer = road.RoadContainer;

        List<StraightMovement> cars = GetAllCarsInRoad(carsContainer);
        AddEngineAudioToCars(cars);
    }

    private void AddEngineAudioToCars(List<StraightMovement> cars)
    {
        foreach (StraightMovement car in cars)
        {
            AddEngineAudioToCar(car);
        }
    }

    private void AddEngineAudioToCar(StraightMovement car)
    {
        if (car.GetComponent<EngineAudio>() != null) return;
        EngineAudio engineAudio = car.gameObject.AddComponent<EngineAudio>();
        engineAudio.engineClip = carAudio;
        engineAudio.target = transform;
    }

    private List<StraightMovement> GetAllCarsInRoad(GameObject gameObject)
    {
        return gameObject.GetComponentsInChildren<StraightMovement>().ToList();
    }
}
