﻿using UnityEngine;

public class AbilityInteract : MonoBehaviour
{

    public float interactDistance = 1f;

    private new BoxCollider2D collider;
    private new SpriteRenderer renderer;
    private new Animator anim;

    void Start()
    {
        collider = GetComponent<BoxCollider2D>();
        renderer = GetComponent<SpriteRenderer>();
        anim = GetComponent<Animator>();
    }

    private void Update()
    {
        if (Input.GetButtonDown("Interact"))
        {
            Interact();
            anim.SetTrigger("interact");
        }
    }

    public void Interact()
    {
        ContactFilter2D filterObstacles = new ContactFilter2D();
        filterObstacles.NoFilter();

        RaycastHit2D[] results = new RaycastHit2D[5];
        collider.Cast(Vector2.right * (renderer.flipX ? -1 : 1), filterObstacles, results, interactDistance);
        foreach (RaycastHit2D result in results)
        {
            if (result.collider == null) continue;
            Interactable interactable = result.collider.GetComponent<Interactable>();
            if (interactable == null) continue;
            interactable.Interact();
        }
    }

}
