﻿
using UnityEngine;

public class MoveWithKeys : MonoBehaviour
{
    public float HorizontalSpeed = 10f;
    public float VerticalSpeed = 7f;

    private new Rigidbody2D rigidbody;
    private new BoxCollider2D collider;

    private new SpriteRenderer renderer;

    public LayerMask collideMask;

    private Animator anim;

    void Start()
    {
        rigidbody = GetComponent<Rigidbody2D>();
        collider = GetComponent<BoxCollider2D>();
        anim = GetComponent<Animator>();
        renderer = GetComponent<SpriteRenderer>();
    }

    void FixedUpdate()
    {
        Vector2 movement = new Vector2()
        {
            x = Input.GetAxisRaw("Horizontal") * HorizontalSpeed,
            y = Input.GetAxisRaw("Vertical") * VerticalSpeed
        };
        movement = movement * Time.deltaTime;
        movement = ClampMovementToCollide(movement);
        transform.Translate(movement);

        if (Mathf.Abs(movement.x) > 0.1f)
        {
            renderer.flipX = movement.x < 0;
        }
        anim.SetFloat("speed", movement.magnitude);
    }

    Vector2 ClampMovementToCollide(Vector2 movement)
    {
        ContactFilter2D filterObstacles = new ContactFilter2D();
        filterObstacles.SetLayerMask(collideMask);
        filterObstacles.useTriggers = true;

        RaycastHit2D[] results = new RaycastHit2D[1];
        /*collider.Cast(Vector2.right * Mathf.Sign(movement.x), filterObstacles, results, Mathf.Abs(movement.x));
        if (results[0].collider != null) movement.x = 0;

        collider.Cast(Vector2.up * Mathf.Sign(movement.y), filterObstacles, results, Mathf.Abs(movement.y));
        if (results[0].collider != null) movement.y = 0;*/

        collider.Cast(movement.normalized, filterObstacles, results, Mathf.Abs(movement.magnitude));
        if (results[0].collider != null) movement = Vector2.zero;

        return movement;
    }

    private void OnDisable()
    {
        anim.SetFloat("speed", 0);
    }
}
