﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ReflectPositionFromFlipX : MonoBehaviour
{

    [SerializeField] SpriteRenderer flippingRenderer;

    private float initialSign;

    private void Awake()
    {
        initialSign = Mathf.Sign(transform.localPosition.x) * Mathf.Sign(flippingRenderer.flipX ? -1 : 1);
    }

    void Update()
    {
        Vector3 newPosition = transform.localPosition;
        newPosition.x = Mathf.Abs(newPosition.x) * Mathf.Sign(flippingRenderer.flipX ? -1 : 1) * initialSign;
        transform.localPosition = newPosition;
    }
}
