﻿
using UnityEngine;

public class SpawnCarsPeriodically : MonoBehaviour
{
    public float minRandomTime = 1;
    public float maxRandomTime = 5;
    public StraightMovement carPrefab;
    public Vector2 direction;
    public bool flipX = false;

    public GameObject spawnParent;

    private float spawnAt = -1;

    private void Start()
    {
        SetNextSpawnTime();
    }

    private void SetNextSpawnTime()
    {
        spawnAt = Time.time + Random.Range(minRandomTime, maxRandomTime);
    }

    void Update()
    {
        SpawnObjectIfNecessary();
    }

    private void SpawnObjectIfNecessary()
    {
        if (Time.time > spawnAt)
        {
            SpawnObject();
            SetNextSpawnTime();
        }
    }

    private void SpawnObject()
    {
        StraightMovement newGameObject = Instantiate(carPrefab, spawnParent.transform);
        newGameObject.direction = direction;
        newGameObject.transform.position = transform.position;
        if (flipX)
        {
            Vector3 newScale = newGameObject.transform.localScale;
            newScale.x *= -1;
            newGameObject.transform.localScale = newScale;
        }
    }
}
