﻿
using UnityEngine;

public class StraightMovement : MonoBehaviour
{
    public float speed = 20f;
    public Vector2 direction;
    [SerializeField] private LayerMask stopsOnLayers;

    private float lookAheadDistance = 20f;

    private new Collider2D collider;
    private ContactFilter2D filterObstacles;

    private void Start()
    {
        collider = GetComponent<Collider2D>();
        filterObstacles = new ContactFilter2D();
        filterObstacles.SetLayerMask(stopsOnLayers);
    }

    void Update()
    {
        if (CanMove())
        {
            transform.Translate(direction * speed * Time.deltaTime);
        }
    }

    private bool CanMove()
    {
        RaycastHit2D[] results = new RaycastHit2D[1];
        collider.Cast(direction, filterObstacles, results, lookAheadDistance);
        if (results[0].collider != null) return false;

        return true;
    }
}
