﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ThinkingCloud : MonoBehaviour
{
    [SerializeField] SpriteRenderer targetSpriteRenderer;

    public float timeToShowEachImage = 2f;

    private Queue<Sprite> imageQueue = new Queue<Sprite>();

    public void EnqueueImageToShow(Sprite sprite)
    {
        imageQueue.Enqueue(sprite);
        if (!gameObject.activeSelf) gameObject.SetActive(true);
    }

    void OnEnable()
    {
        StartCoroutine(ShowRoutine());
    }

    private IEnumerator ShowRoutine()
    {
        while (imageQueue.Count > 0)
        {
            Sprite nextSprite = imageQueue.Dequeue();
            targetSpriteRenderer.sprite = nextSprite;
            yield return new WaitForSeconds(timeToShowEachImage);
        }
        gameObject.SetActive(false);
    }

    private void OnDisable()
    {
        StopAllCoroutines();
    }

}
