﻿
using System;
using UnityEngine;

public static class Extensions
{
    public static bool IsInLayerMask(this GameObject gameObject, LayerMask layerMask)
    {
        return layerMask == (layerMask | (1 << gameObject.layer));
    }

    public static void SafeInvoke(this Action action)
    {
        if (action != null) action.Invoke();
    }

    public static void SafeInvoke<T>(this Action<T> action, T param)
    {
        if (action != null) action.Invoke(param);
    }

    public static void SafeInvoke<T, U>(this Action<T, U> action, T param, U param2)
    {
        if (action != null) action.Invoke(param, param2);
    }

    public static void SafeInvoke<T, U, V>(this Action<T, U, V> action, T param, U param2, V param3)
    {
        if (action != null) action.Invoke(param, param2, param3);
    }

    public static int Mod(this int x, int m)
    {
        return (x % m + m) % m;
    }
}